;
;
;  Usage :
;	-pktentry
;	_pktasminit( void far * buffers, int maxbufs, int buflen)
;
;  (c) 1991 University of Waterloo,
;	Faculty of Engineering,
;	Engineering Microcomputer Network Development Office
;
;  version
;
;    0.1    22-May-1992   E. P. Engelke
;
;
	include masmdefs.hsm
	include model.hsm

codedef	ASMPKT
datadef

datastart
maxbufs	dw      0
maxlen	dw      0
bufs	dw      0
bufseg	dw      0
dataend

cstart	ASMPKT

cproc	_pktentry
	pushf

	cli		; no interruptions now

	or	AL, AL
	jnz	encue   ; branch if was a 1 and must encue packet now

	; buffer request operation
	; to check our buffers we will need the same DS seg, set it now
	push	CX
	push	DS
	mov	DI, _DATA
	mov	DS, DI
	assume	DS:_DATA
	les	DI, dword ptr DS:bufs

	; check the packet length
	cmp	CX, DS:maxlen
	jg	no_fnd		; pretend none were found

	mov	CX, DS:maxbufs
	mov	AL, 0ffh

srcloop:test	AL, byte ptr ES:DI
	jz	found
	add	DI, DS:maxlen
	add	DI, 2
	loop	srcloop

no_fnd:	xor	DI, DI		; for whatever error, throw away the buffer
	mov	ES, DI		; by returning 0000:0000
	sub	DI, 2

found:	add	DI, 2
	pop	DS
	assume	DS:nothing
	pop	CX
	popf
	retf

	; encue packet
	;
encue:	or	SI, SI
	jz	no_enqu		; not a valid pointer, cannot encue
	push	SI
	sub	SI, 2
	mov	AL, 1		; should be already, but just in case
	mov	byte ptr DS:SI, AL
	pop	SI
no_enqu:popf
	retf
cendp	_pktentry

cpublic	_pktasminit		; bufptr, maxbufs, buflen
	push	ES
	mov	AX, _DATA
	mov	ES, AX
	assume	ES:_DATA
	mov	AX, +@AB + 0 [BP]	; bufptr
	mov	BX, +@AB + 2 [BP]	; bufptr segment
	mov	CX, +@AB + 4 [BP]	; maxbufs
	mov	DX, +@AB + 6 [BP]	; buflen
	mov	ES:bufs, AX
	mov	ES:bufseg, BX
	mov	ES:maxbufs, CX
	mov	ES:maxlen, DX
	pop	ES
creturn	_pktasminit
cend	ASMPKT
	end
